﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinDock;

namespace UltraDockManagerSaveLayout
{
    public partial class Form1 : Form
    {
        public UltraPanel Panel1 { get; set; }

        public DockAreaPane dockArea;
        public DockableGroupPane dgp;

        public int count;
        public Form1()
        {
            InitializeComponent();
            dockArea = new DockAreaPane(DockedLocation.DockedRight);
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            count++;
            Panel1 = new UltraPanel();
            Panel1.Size = new System.Drawing.Size(200, 200);
            Panel1.Appearance.BackColor = Color.Red;

            UltraButton ub = new UltraButton();
            ub.Text = "Add new";
            ub.Click += new EventHandler(ub_Click);
            ub.Size = new System.Drawing.Size(75, 25);
            Panel1.ClientArea.Controls.Add(ub);

            if (count >= 2)
            {
                DockableControlPane olddcp = ultraDockManager1.ControlPanes.GetItem(ultraDockManager1.ControlPanes.IndexOf("Panel " + (count - 1).ToString())) as DockableControlPane;
                dgp = olddcp.Parent;
            }
            else
            {
                dgp = new DockableGroupPane("DGP " + count.ToString());
            }

            if (dgp.ChildPaneStyle == ChildPaneStyle.TabGroup)
            {
                dgp = new DockableGroupPane("DGP " + count.ToString());
            }

            DockableControlPane dcp1 = new DockableControlPane("Panel " + count.ToString(), "Panel " + count.ToString(), Panel1);
            dcp1.Control = Panel1;
            dgp.Panes.Add(dcp1);
            ultraDockManager1.DockAreas.Add(dockArea);

            if (dgp.Panes.Count > 2 && dgp.ChildPaneStyle != ChildPaneStyle.TabGroup)
            {
                dgp.ChildPaneStyle = ChildPaneStyle.TabGroup;
                dockArea.Panes.Add(dgp);
                ultraDockManager1.DockAreas.Add(dockArea);
            }
            else
            {
                dgp.ChildPaneStyle = ChildPaneStyle.HorizontalSplit;
                dockArea.Panes.Add(dgp);
                ultraDockManager1.DockAreas.Add(dockArea);
            }
        }

        void ub_Click(object sender, EventArgs e)
        {
            ultraButton1_Click(sender, e);
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraDockManager1.SaveAsXML("..\\..\\Test.xml");
        }

        private void ultraButton3_Click(object sender, EventArgs e)
        {
            ultraDockManager1.HideAll();
            ultraDockManager1.LoadFromXML("..\\..\\Test.xml");
        }

    }
}
